using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SkySof;
using System.IO;
using System.Diagnostics;

namespace CSharp_Demo
{
    public partial class Form1 : Form
    {

        SkySof.DWGminer o;
        string path = Environment.CurrentDirectory + "\\";
        int xlver;
        int dcols;
        int drows;
        string sFile;
        string sMsg; 

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
                o = new SkySof.DWGminer();
                ListViewItem lItem = default(ListViewItem);
                ListView1.Columns.Add("Drawing", 300, HorizontalAlignment.Left);
                ListView1.Columns.Add("Name", 100, HorizontalAlignment.Left);
                ListView1.Columns.Add("Display", 50, HorizontalAlignment.Left);
                object oxl = null;
                try
                {
                    xlver = 11; // set this to proper Excel Version Number
                    // 2003 = 11
                    // 2007 = 12
                }
                catch (Exception ex)
                {
                    xlver = -1;
                    MessageBox.Show(ex.ToString());
                }
        }

        private void Button1_Click(object sender, EventArgs e)
        {
            if (xlver == -1)
            {
                MessageBox.Show("Excel must be installed to perform this operation","Excel Required");
            }
            string r = null;
            int i = 0;
            object arr = null;
            r = o.OpenDrawing(path + "attext.dwg", "");
            i = o.CreateBlockAttributeArray(ref arr, DWGminer.DrawingSpaceType.dwgBoth, "", "", "", DWGminer.DrawingFieldType.dwgDrawingFullName, true, null);
            r = o.CloseDrawing();
            if (arr == null)
            {
                MessageBox.Show("empty");
            }
            else
            {
                string xlwb = path + "attext.xls";
                if (xlver > 11)
                {
                    xlwb = xlwb + "x";
                }
                if (File.Exists(xlwb))
                {
                    File.Delete(xlwb);
                }
                i = o.ArrayToExcel((System.Array) arr, 1, 1, "", false, xlwb, 1, "", "", true,
                false, true, true, false, false, "Block Attribute Values", true);
                //Release Excel COM Object 
                GC.Collect();
                GC.WaitForPendingFinalizers();
                if (File.Exists(xlwb))
                {
                    Process.Start(xlwb);
                }
                else
                {
                    MessageBox.Show("File not found: " + xlwb);
                }
            }
        }

        private void Button2_Click(object sender, EventArgs e)
        {
            if (xlver == -1)
            {
                MessageBox.Show("Excel must be installed to perform this operation", "Excel Required");
            }
            string r = null;
            int i = 0;
            object arr = null;
            r = o.OpenDrawing(path + "attext.dwg", "");
            r = o.CreateXML(path + "attext.xml", 1, 0, 0, 0, 0, 0, 0, 0);
            r = o.CloseDrawing();
            //NOTE: A filter of "LAYOUT = 'model' AND LAYERNAME = 'xt'" is being used in method below 
            //Remove the filter to get all the block attributes in the drawing 
            i = o.XMLfileToArray(path + "attext.xml", DWGminer.ChapterType.dwgBlocksAndAttributes, ref arr, true, "LAYOUT = 'model' AND LAYERNAME = 'xt'", null, DWGminer.DrawingFieldType.dwgDrawingFullName);
            string xlwb = path + "block.xls";
            if (xlver > 11)
            {
                xlwb = xlwb + "x";
            }
            if (File.Exists(xlwb))
            {
                File.Delete(xlwb);
            }
            i = o.ArrayToExcel((System.Array) arr, 1, 1, "", false, xlwb, 1, "", "", true,
            false, true, true, false, false, "Block Attribute Values", true);
            //Release Excel COM Object 
            GC.Collect();
            GC.WaitForPendingFinalizers();
            if (File.Exists(xlwb))
            {
                Process.Start(xlwb);
            }
            else
            {
                MessageBox.Show("File not found: " + xlwb);
            }
        }

        private void Button3_Click(object sender, EventArgs e)
        { 
            string r = null; 
            int i = 0; 
            object arr = null; 
            r = o.OpenDrawing(path + "attext.dwg", ""); 
            r = o.CreateXML(path + "attext.xml", 1, 0, 0, 0, 0, 0, 0, 0); 
            r = o.CloseDrawing(); 
            //NOTE: A filter of "LAYOUT = 'model'" is being used in method below 
            //Remove the filter to get all the block attributes in the drawing 
            i = o.XMLfileToArray(path + "attext.xml", DWGminer.ChapterType.dwgBlocksAndAttributes, ref arr, true, "LAYOUT = 'model'", null, DWGminer.DrawingFieldType.dwgDrawingFullName); 
            if (File.Exists(path + "attext.htm")) { 
                File.Delete(path + "attext.htm"); 
            }
            i = o.ArrayToHTMLFile((System.Array) arr, path + "attext.htm", "ATTEXT.DWG", "ATTEXT.DWG", path + "image.jpg", "", DWGminer.TableAlignType.dwgCenter, "", "#FFD700", 1, 
            "black", 2, 2, 10, DWGminer.TableAlignType.dwgRight, false, true, false, 18, false 
            ); 
            if (File.Exists(path + "attext.htm")) { 
                Process.Start(path + "attext.htm"); 
            } 
            else { 
                MessageBox.Show("File not found: " + path + "attext.htm"); 
            } 
        }

        private void Button4_Click(object sender, EventArgs e)
        {
            string r = null;
            int i = 0;
            object arr = null;
            r = o.OpenDrawing(path + "attext.dwg", "");
            r = o.CreateXML(path + "attext.xml", 1, 0, 0, 0, 0, 0, 0, 0);
            r = o.CloseDrawing();
            //NOTE: A filter of "LAYOUT = 'model'" is being used in method below 
            //Remove the filter to get all the block attributes in the drawing 
            i = o.XMLfileToArray(path + "attext.xml", DWGminer.ChapterType.dwgBlocksAndAttributes, ref arr, true, "LAYOUT = 'model'", null, DWGminer.DrawingFieldType.dwgDrawingFullName);
            if (File.Exists(path + "attext.csv"))
            {
                File.Delete(path + "attext.csv");
            }
            i = o.ArrayToTextFile((System.Array) arr, path + "attext.csv", ",", true, false);
            if (File.Exists(path + "attext.csv"))
            {
                Process.Start(path + "attext.csv");
            }
            else
            {
                MessageBox.Show("File not found: " + path + "attext.csv");
            }
        }

        private void Button5_Click(object sender, EventArgs e)
        {
            int i = 0;
            string r = null;
            object arr = null;
            ListView1.Items.Clear();
            r = o.OpenDrawing(path + "attext.dwg", "");
            r = o.CreateXML(path + "attext.xml", 0, 0, 0, 1, 0, 0, 0, 0);
            r = o.CloseDrawing();
            //NOTE: A filter of "NAME LIKE 'x%'" is being used in method below 
            //Remove the filter to get all the block attributes in the drawing 
            i = o.XMLfileToArray(path + "attext.xml", DWGminer.ChapterType.dwgLayers, ref arr, false, "NAME LIKE 'x%'", null, DWGminer.DrawingFieldType.dwgDrawingFullName);
            i = o.ArrayToListView(arr, ListView1, null);
        }

        private void Button6_Click(object sender, EventArgs e)
        {
            int i = 0;
            string r = null;
            DataSet ds = default(DataSet);
            r = o.OpenDrawing(path + "attext.dwg", "");
            r = o.CreateXML(path + "attext.xml", 1, 0, 0, 0, 0, 0, 0, 0);
            r = o.CloseDrawing();
            i = o.FlattenXMLfile(path + "attext.xml", path + "flat.xml", DWGminer.ChapterType.dwgBlocksAndAttributes, DWGminer.DrawingFieldType.dwgDrawingFullName);
            //NOTE: A filter of "LayerName LIKE 'x%'" is being used in method below 
            //Remove the filter to get all the block attributes in the drawing 
            ds = o.XMLFileToDataGrid(path + "flat.xml", DataGrid1, "LayerName LIKE 'x%'", "Layout,AttributeTag");
            if (ds == null)
            {
                MessageBox.Show("Unable to open");
            }
            else
            {
                DataTable tbl = ds.Tables[0];
                dcols = tbl.Columns.Count;
                drows = tbl.Rows.Count;
                MessageBox.Show("Make some changes in column 'AttributeValue' then click button 'Update Block Attribute Values'");
            }
        }

        private void Button8_Click(object sender, EventArgs e)
        {
            object arr = null;
            string[] fields = new string[3];

            fields[0] = "AttributeHandle";
            fields[1] = "AttributeTag";
            fields[2] = "AttributeValue";

            sFile = path + "attext.dwg";

            sMsg = o.OpenDrawing(sFile, "");

            if (sMsg != "OK")
            {
                MessageBox.Show("Unable to open drawing.\n" + sMsg, "Drawing Error");
                return;
            }

            //Create XML file containing block attribute data 
            o.CreateXML(path + "file.xml", 1, 0, 0, 0, 0, 0, 0, 0);

            o.CloseDrawing();

            //Move XML file to a two dimensional array 
            //Use argument strFilter to specify a filter for recordset 
            //Use argument varFields to specify one or more fields. Pass as a string or one dimensional array. If not passed all fields are returned. 
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgBlocksAndAttributes, ref arr, true, "LayerName LIKE 'x%'", fields, DWGminer.DrawingFieldType.dwgNone);

            if (arr == null)
            {
                MessageBox.Show("Information not found.");
                return;
            }

            int i = 0;
            int n = 0;
            string r = null;
            string s = null;

            Array ar = (Array)arr;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 3)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Attribute values before update");

            s = null;

            if (InputBox("Enter new value for tag TITLE_1", "Set Attribute Value", ref s) != DialogResult.OK)
                return;

            if (s == null) return;
            
            o.OpenDrawing(sFile, "");

            ////Replace attribute value by attribute tag name 
            String attribute_handle = "";
            foreach (object a in ar)
            {
                if ((String) a == "TITLE_1")
                {
                    o.UpdateBlockAttribute(s, attribute_handle);
                }
                attribute_handle = (String) a;
            }

            o.SaveDrawing(sFile, DWGminer.SaveAutoCADversionType.dwgSaveAsDefault);
            o.OpenDrawing(sFile, "");
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgBlocksAndAttributes, ref arr, true, "LayerName LIKE 'x%'", fields, DWGminer.DrawingFieldType.dwgNone);

            s = null;

            ar = (Array) arr;

            i = 0;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 3)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Attribute values after update");

            s = null;

            InputBox("Enter attribute value to search for", "Set Attribute Value", ref s);

            if (s == null) return;

            InputBox("Enter replacement text", "Set Replacement Value", ref r);

            if (r == null) return;
            
            o.OpenDrawing(sFile, "");

            ////Replace attribute value by attribute value 
            for (n = 0; n < ar.GetUpperBound(0); n++)
            {
                //for (i = 0; i <= ar.GetUpperBound(1); i++)
                //{
                //    MessageBox.Show(ar.GetValue(n,i).ToString());
                
                if (ar.GetValue(n,2).ToString().ToLower() == s.ToLower())
                   {
                    //replace whole 
                    //o.UpdateBlockAttribute(r, ar.GetValue(n, 0).ToString());
                    //replace partial 
                    o.UpdateBlockAttribute(r.Replace(s,r), ar.GetValue(n, 0).ToString());
                   }
                
            }

            o.SaveDrawing(sFile, DWGminer.SaveAutoCADversionType.dwgSaveAsDefault);
            o.OpenDrawing(sFile, "");
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgBlocksAndAttributes, ref arr, true, "LayerName LIKE 'x*'", fields, DWGminer.DrawingFieldType.dwgNone);

            s = null;

            ar = (Array)arr;

            i = 0;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 3)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Attribute values after update");

            o.CloseDrawing();
        }

        private void Button10_Click(object sender, EventArgs e)
        {
            object arr = null;
            string[] fields = new string[3];

            fields[0] = "AttributeHandle";
            fields[1] = "AttributeTag";
            fields[2] = "AttributeValue";

            sFile = path + "attext.dwg";

            sMsg = o.OpenDrawing(sFile, "");

            if (sMsg != "OK")
            {
                MessageBox.Show("Unable to open drawing.", "Drawing Error");
                return;
            }

            //Create XML file containing block attribute data 
            o.CreateXML(path + "file.xml", 1, 0, 0, 0, 0, 0, 0, 0);

            o.CloseDrawing();

            //Move XML file to a two dimensional array 
            //Use argument strFilter to specify a filter for recordset 
            //Use argument varFields to specify one or more fields. Pass as a string or one dimensional array. If not passed all fields are returned. 
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgBlocksAndAttributes, ref arr, true, "LayerName LIKE 'x%'", fields, DWGminer.DrawingFieldType.dwgNone);

            if (arr == null)
            {
                MessageBox.Show("Information not found.");
                return;
            }

            int i = 0;
            int n = 0;
            string r = null;
            string s = null;

            Array ar = (Array)arr;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 3)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Attribute values before update");

            s = null;

            if (InputBox("Enter new value for tag TITLE_1", "Set Attribute Value", ref s) != DialogResult.OK)
                return;

            if (s == null) return;
            
            o.OpenDrawing(sFile, "");

            //Find and replace block attribute value by tag name 
            //Note: to find and replace all block attribute values pass "*" to parameter strTextToFind 
            i = o.FindAndReplaceBlockAttributes("title_1", s, true, true, true, false, "", null);

            o.SaveDrawing(sFile, DWGminer.SaveAutoCADversionType.dwgSaveAsDefault);
            o.OpenDrawing(sFile, "");
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgBlocksAndAttributes, ref arr, true, "LayerName LIKE 'x%'", fields, DWGminer.DrawingFieldType.dwgNone);

            ar = (Array)arr;

            s = null;

            i = 0;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 3)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Attribute values after update");

            s = null;

            InputBox("Enter attribute value to search for", "Set Attribute Value", ref s);

            if (s == null) return;

            InputBox("Enter replacement text", "Set Replacement Value", ref r);

            if (r == null) return;
            
            o.OpenDrawing(sFile, "");

            //Find and replace block attribute value by value 
            i = o.FindAndReplaceBlockAttributes(s, r, false, false, false, false, "", null);

            o.SaveDrawing(sFile, DWGminer.SaveAutoCADversionType.dwgSaveAsDefault);
            o.OpenDrawing(sFile, "");
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgBlocksAndAttributes, ref arr, true, "LayerName LIKE 'x%'", fields, DWGminer.DrawingFieldType.dwgNone);

            ar = (Array)arr;

            s = null;

            i = 0;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 3)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Attribute values after update");

            o.CloseDrawing();
        } 

        private void Button9_Click(object sender, EventArgs e)
        {
            object arr = null;
            string[] fields = new string[2];

            fields[0] = "Handle";
            fields[1] = "Value";

            sFile = path + "attext.dwg";

            sMsg = o.OpenDrawing(sFile, "");

            if (sMsg != "OK")
            {
                MessageBox.Show("Unable to open drawing.", "Drawing Error");
                return;
            }

            //Create XML file containing text values 
            o.CreateXML(path + "file.xml", 0, 0, 0, 0, 0, 0, 0, 1);

            o.CloseDrawing();

            //Move XML file to a two dimensional array 
            //Use argument strFilter to specify a filter for recordset 
            //Use argument varFields to specify one or more fields. Pass as a string or one dimensional array. If not passed all fields are returned. 
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgText, ref arr, true, "Block = 'd00005d1' AND Value LIKE 'farmington%'", fields, DWGminer.DrawingFieldType.dwgNone);

            if (arr == null)
            {
                MessageBox.Show("Information not found.");
                return;
            }

            int i = 0;
            int n = 0;
            string r = null;
            string s = null;

            Array ar = (Array)arr;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 2)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Text values before update");

            s = null;

            if (InputBox("Enter new value for text", "Set Text Value", ref s) != DialogResult.OK)
                return;

            o.OpenDrawing(sFile, "");

            //Replace text value 
            for (n = 1; n <= ar.GetUpperBound(0); n++)
            {
                //We skip row 0 because it contains headers 
                o.UpdateText(s, ar.GetValue(n,1).ToString());
            }

            o.SaveDrawing(sFile, DWGminer.SaveAutoCADversionType.dwgSaveAsDefault);
            o.OpenDrawing(sFile, "");
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgText, ref arr, true, "Value = '" + s + "'", fields, DWGminer.DrawingFieldType.dwgNone);

            s = null;

            ar = (Array)arr;

            i = 0;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 2)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Text values after update");

            //Now restore text to what it was 
            o.OpenDrawing(sFile, "");

            for (n = 1; n <= ar.GetUpperBound(0); n++)
            {
                //We skip row 0 because it contains headers 
                o.UpdateText("FARMINGTON HILLS, MI", ar.GetValue(n, 1).ToString());
            }

            o.SaveDrawing(sFile, DWGminer.SaveAutoCADversionType.dwgSaveAsDefault);

            o.CloseDrawing();
        } 

        public static DialogResult InputBox(string title, string promptText, ref string value)
        {
            Form form = new Form();
            Label label = new Label();
            TextBox textBox = new TextBox();
            Button buttonOk = new Button();
            Button buttonCancel = new Button();

            form.Text = title;
            label.Text = promptText;
            textBox.Text = value;

            buttonOk.Text = "OK";
            buttonCancel.Text = "Cancel";
            buttonOk.DialogResult = DialogResult.OK;
            buttonCancel.DialogResult = DialogResult.Cancel;

            label.SetBounds(9, 20, 372, 13);
            textBox.SetBounds(12, 36, 372, 20);
            buttonOk.SetBounds(228, 72, 75, 23);
            buttonCancel.SetBounds(309, 72, 75, 23);

            label.AutoSize = true;
            textBox.Anchor = textBox.Anchor | AnchorStyles.Right;
            buttonOk.Anchor = AnchorStyles.Bottom | AnchorStyles.Right;
            buttonCancel.Anchor = AnchorStyles.Bottom | AnchorStyles.Right;

            form.ClientSize = new Size(396, 107);
            form.Controls.AddRange(new Control[] { label, textBox, buttonOk, buttonCancel });
            form.ClientSize = new Size(Math.Max(300, label.Right + 10), form.ClientSize.Height);
            form.FormBorderStyle = FormBorderStyle.FixedDialog;
            form.StartPosition = FormStartPosition.CenterScreen;
            form.MinimizeBox = false;
            form.MaximizeBox = false;
            form.AcceptButton = buttonOk;
            form.CancelButton = buttonCancel;

            DialogResult dialogResult = form.ShowDialog();
            value = textBox.Text;
            return dialogResult;
        }

        private void Button11_Click(object sender, EventArgs e)
        {
            object arr = null;
            string[] fields = new string[2];

            fields[0] = "Handle";
            fields[1] = "Value";

            sFile = path + "attext.dwg";

            sMsg = o.OpenDrawing(sFile, "");

            if (sMsg != "OK")
            {
                MessageBox.Show("Unable to open drawing.", "Drawing Error");
                return;
            }

            //Create XML file containing text values 
            o.CreateXML(path + "file.xml", 0, 0, 0, 0, 0, 0, 0, 1);

            o.CloseDrawing();

            //Move XML file to a two dimensional array 
            //Use argument strFilter to specify a filter for recordset 
            //Use argument varFields to specify one or more fields. Pass as a string or one dimensional array. If not passed all fields are returned. 
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgText, ref arr, true, "Block = 'd00005d1' AND Value LIKE 'farmington%'", fields, DWGminer.DrawingFieldType.dwgNone);

            if (arr == null)
            {
                MessageBox.Show("Information not found.");
                return;
            }

            int i = 0;
            int n = 0;
            string r = null;
            string s = null;

            Array ar = (Array)arr;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 2)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Text values before update");

            s = null;
            
            if (InputBox("Enter new value for text", "Set Text Value", ref s) != DialogResult.OK)
                return;

            o.OpenDrawing(sFile, "");

            //Find and replace text 
            //Note: to find and replace all text values pass "*" to parameter strTextToFind 
            i = o.FindAndReplaceText("farmington", s, DWGminer.TextType.dwgSingleLine, false, true, false, "Block = 'd00005d1'");

            o.SaveDrawing(sFile, DWGminer.SaveAutoCADversionType.dwgSaveAsDefault);
            o.OpenDrawing(sFile, "");
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgText, ref arr, true, "Value = '" + s + "'", fields, DWGminer.DrawingFieldType.dwgNone);

            s = null;

            ar = (Array)arr;

            i = 0;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 2)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Text values after update");

            //Now restore text to what it was 
            o.OpenDrawing(sFile, "");
            for (n = 1; n <= ar.GetUpperBound(0); n++)
            {
                //We skip row 0 because it contains headers 
                o.UpdateText("FARMINGTON HILLS, MI", ar.GetValue(n, 1).ToString());
            }

            o.SaveDrawing(sFile, DWGminer.SaveAutoCADversionType.dwgSaveAsDefault);

            o.CloseDrawing();
        }

        private void Button12_Click(object sender, EventArgs e)
        {
            object arr = null;

            sFile = path + "attext.dwg";

            sMsg = o.OpenDrawing(sFile, "");

            if (sMsg != "OK")
            {
                MessageBox.Show("Unable to open drawing.", "Drawing Error");
                return;
            }

            //Create XML file containing layer data 
            o.CreateXML(path + "file.xml", 0, 0, 0, 1, 0, 0, 0, 0);

            //Move XML file to a two dimensional array 
            //Use argument strFilter to specify a filter for recordset 
            //Use argument varFields to specify one or more fields. Pass as a string or one dimensional array. If not passed all fields are returned. 
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgLayers, ref arr, true, "", null, DWGminer.DrawingFieldType.dwgNone);

            if (arr == null)
            {
                MessageBox.Show("Information not found.");
                return;
            }

            int n = 0;
            int i = 0;
            string s = null;

            Array ar = (Array)arr;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 3)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Values before update");

            MessageBox.Show("Set all layers off");

            for (n = 0; n <= ar.GetUpperBound(0); n++)
            {
                o.SetLayerState(ar.GetValue(n, 0).ToString(), DWGminer.LayerStateType.dwgOff, DWGminer.LayerModeType.dwgOnOff);
            }

            o.SaveDrawing(path + "attext.dwg", DWGminer.SaveAutoCADversionType.dwgSaveAsDefault);
            //oDM.SaveDrawing sAppPath & "woodbldg.dwg" 

            //Create XML file containing block attribute data 
            o.CreateXML(path + "file.xml", 0, 0, 0, 1, 0, 0, 0, 0);

            //Move XML file to a two dimensional array 
            //Use argument strFilter to specify a filter for recordset 
            //Use argument varFields to specify one or more fields. Pass as a string or one dimensional array. If not passed all fields are returned. 
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgLayers, ref arr, true, "", null, DWGminer.DrawingFieldType.dwgNone);

            ar = (Array)arr;

            s = null;

            i = 0;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 3)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Values after update");

            MessageBox.Show("Set all layers on");

            for (n = 0; n <= ar.GetUpperBound(0); n++)
            {
                o.SetLayerState(ar.GetValue(n, 0).ToString(), DWGminer.LayerStateType.dwgOn, DWGminer.LayerModeType.dwgOnOff);
            }

            o.SaveDrawing(path + "attext.dwg", DWGminer.SaveAutoCADversionType.dwgSaveAsDefault);

            //Create XML file containing block attribute data 
            o.CreateXML(path + "file.xml", 0, 0, 0, 1, 0, 0, 0, 0);

            o.CloseDrawing();

            //Move XML file to a two dimensional array 
            //Use argument strFilter to specify a filter for recordset 
            //Use argument varFields to specify one or more fields. Pass as a string or one dimensional array. If not passed all fields are returned. 
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgLayers, ref arr, true, "", null, DWGminer.DrawingFieldType.dwgNone);

            ar = (Array)arr;

            s = null;

            i = 0;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 3)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Values after update");
        }

        private void Button13_Click(object sender, EventArgs e)
        {
            sFile = path + "attext.dwg";

            sMsg = o.OpenDrawing(sFile, "");

            if (sMsg != "OK")
            {
                MessageBox.Show("Unable to open drawing.", "Drawing Error");
                return;
            }

            //Argument intPrecision is a number 0 through 16 
            o.CreateDXF(path + "file.dxf", 16, DWGminer.AutoCADversionType.dwgVersion2004);
            o.CloseDrawing();
            //Display the DXF file 
            Process.Start("notepad.exe", path + "file.dxf");
        }

        private void Button14_Click(object sender, EventArgs e)
        
        { 
            MessageBox.Show("This demo extracts block attribute values from 2 drawings and creates an Excel workbook containing the information."); 
            
            if (xlver == -1) { 
                MessageBox.Show("Excel must be installed to perform this operation"); 
            } 
            
            object arr = null; 
            
            sFile = path + "attext.dwg"; 
            
            sMsg = o.OpenDrawing(sFile, ""); 
            
            if (sMsg != "OK") { 
                MessageBox.Show("Unable to open drawing.", "Drawing Error"); 
                return; 
            } 
            
            bool blnHeaders = true;
            
            int i = 2; 
            int t = 0; 
            
            //Note: Each block's attribute tags must be identical otherwise function 
            //CreateBlockAttributeArray will fail. To use a specific block and 
            o.CreateBlockAttributeArray(ref arr, DWGminer.DrawingSpaceType.dwgBoth, "", "", "", DWGminer.DrawingFieldType.dwgDrawingFullName, blnHeaders, null); 
            //This example uses specific drawing space, layout, block, and layer 
            //o.CreateBlockAttributeArray(ref arr, dwgModel, "model", "d00005d1", "xt", i, blnHeaders)
            //The example below uses specific block attribute tags 
            //o.CreateBlockAttributeArray(ref arr, dwgBoth, , , , i, blnHeaders, Array("TITLE_1", "TITLE_2", "CUSTOMER'S_NAME", "RB")) 
            o.CloseDrawing(); 
            
            if (arr == null) { 
                MessageBox.Show("Information not found."); 
                return; 
            }

            string xlwb = path + "new.xls";
            if (xlver > 11)
            {
                xlwb = xlwb + "x";
            }
            if (File.Exists(xlwb))
            {
                File.Delete(xlwb);
            }

            o.ArrayToExcel((Array)arr, 1, 1, "", false, xlwb, 1, "", "", true, false, true, blnHeaders, false, false, "Block Attribute Values", true);

            Array ar = (Array)arr;
            
            t = ar.GetUpperBound(0) + 1; 
            
            sFile = path + "attext2.dwg"; 
            
            if (File.Exists(sFile) == false) { 
                File.Copy(path + "attext.dwg", sFile); 
            } 
            
            sMsg = o.OpenDrawing(sFile, ""); 
            
            if (sMsg != "OK") { 
                MessageBox.Show("Unable to open drawing.", "Drawing Error"); 
                return; 
            } 
            
            o.CreateBlockAttributeArray(ref arr, DWGminer.DrawingSpaceType.dwgBoth, "", "", "", DWGminer.DrawingFieldType.dwgDrawingFullName, false, null); 
            //This example uses specific drawing space, layout, block, and layer 
            //o.CreateBlockAttributeArray(ref arr, DWGminer.DrawingSpaceType.dwgModel, "model", "d00005d1", "xt", DWGminer.DrawingFieldType.dwgDrawingFullName, false, null) 
            //The example below uses specific block attribute tags 
            string[] flds = { "TITLE_1", "TITLE_2", "CUSTOMER'S_NAME", "RB" }; 
            o.CreateBlockAttributeArray(ref arr, DWGminer.DrawingSpaceType.dwgBoth, "", "", "", DWGminer.DrawingFieldType.dwgDrawingFullName, false, flds); 
            o.CloseDrawing(); 
            
            if (arr == null) {
                MessageBox.Show("Information not found."); 
                return; 
            }

            o.ArrayToExcel((Array)arr, t + 1, 1, xlwb, true, "", 1, "", "", false, false, false, false, false, false, "", true); 
        }

        private void Button15_Click(object sender, EventArgs e)
        {
            object arr = null;
            string[] fields = new string[3];

            fields[0] = "AttributeHandle";
            fields[1] = "AttributeTag";
            fields[2] = "AttributeValue";

            if (File.Exists(path + "copy.dwg"))
               File.Delete(path + "copy.dwg");
            
            File.Copy(path + "attext.dwg", path + "copy.dwg");

            sFile = path + "copy.dwg";

            sMsg = o.OpenDrawing(sFile, "");

            if (sMsg != "OK")
            {
                MessageBox.Show("Unable to open drawing.", "Drawing Error");
                return;
            }

            //Create XML file containing block attribute data 
            o.CreateXML(path + "file.xml", 1, 0, 0, 0, 0, 0, 0, 0);

            o.CloseDrawing();

            //Move XML file to a two dimensional array 
            //Use argument strFilter to specify a filter for recordset 
            //Use argument varFields to specify one or more fields. Pass as a string or one dimensional array. If not passed all fields are returned. 
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgBlocksAndAttributes, ref arr, true, "LayerName LIKE 'x%'", fields, DWGminer.DrawingFieldType.dwgNone);

            if (arr == null)
            {
                MessageBox.Show("Information not found.");
                return;
            }

            int i = 0;
            int n = 0;
            string r = null;
            string s = null;
            int k = 0;

            Array ar = (Array)arr;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 3)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Attributes before delete");

            o.OpenDrawing(sFile, "");

            //Delete attributes with tag = "TITLE_1" 

            for (n = 0; n <= ar.GetUpperBound(0); n++)
            {
                if (ar.GetValue(n, 1).ToString() == "TITLE_1")
                {
                    //The DeleteObject function can be used to delete objects from 
                    //AutoCAD drawings such as text, block attributes, etc. 
                    o.DeleteObject(ar.GetValue(n, 0).ToString());
                    k = k + 1;
                }
            }

            o.SaveDrawing(sFile, DWGminer.SaveAutoCADversionType.dwgSaveAsDefault);

            MessageBox.Show(k.ToString() + " attributes with tag = 'TITLE_1' have been deleted.");

            o.OpenDrawing(sFile, "");
            o.XMLfileToArray(path + "file.xml", DWGminer.ChapterType.dwgBlocksAndAttributes, ref arr, true, "LayerName LIKE 'x%'", fields, DWGminer.DrawingFieldType.dwgNone);
            o.CloseDrawing();

            ar = (Array)arr;

            s = null;

            i = 0;

            foreach (object a in ar)
            {
                s = s + a + ", ";
                i++;
                if (i == 3)
                {
                    i = 0;
                    s = s + "\n";
                }
            }

            MessageBox.Show(s, "Attributes after delete");
        }

        private void button16_Click(object sender, EventArgs e)
        {
            Process.Start("https://www.regnow.com/softsell/nph-softsell.cgi?item=4459-62");
        }    
    }
}